<template>
  <div class="indicator q-my-xl full-width">

    <div class="indicator__title full-width q-mb-md ">
      <h2>{{ indicatorTitle }}</h2>
    </div>

    <div class="indicator__inputs-container full-width">
      <InputsComponent
        v-model="indicatorDataModel"
        :indicator="props.indicatorType"
        :isFetching="isDataFetching"
      >
        {{ indicatorDesciption }}
      </InputsComponent>
    </div>

    <div class="indicator__outputs-container full-width">
      <div v-show="isDataFetching" class="full-width q-pa-xl row justify-center items-center" >
        <q-spinner
          color="primary"
          size="20em"
          :thickness="5"
        />
      </div>
      <OutputsComponent
        v-if="!isDataFetching"
        :indicator="props.indicatorType"
        :currentDate="currentFormattedDateString"
        :data="data"
      >
        <template v-slot:dynamic_header>
          <DynamicHeaderComponent
            :dynamicHeader="dynamicHeader"
          />
        </template>

        <template v-slot:download_buttons>
          <DownloadButtonsComponent
            :indicator="props.indicatorType"
            :indicatorTitle="indicatorTitle"
            :indicatorDescription="indicatorDesciption"
            :dynamicHeader="dynamicHeader"
            :data="data"
            :isFetching="isDataFetching"
            :toggleSelectedValue="indicatorDataModel.toggleSelectedValue"
          />
        </template>

      </OutputsComponent>
    </div>

  </div>
  <q-separator v-if="isSeparatorNeeded" color="orange" size="1px" class="full-width" />
</template>

<script setup>
import { computed, ref, watchEffect } from 'vue';

import InputsComponent from './inputs-component/InputsComponent.vue';
import OutputsComponent from './outputs-component/OutputsComponent.vue';
import DynamicHeaderComponent from 'src/components/indicator-component/dynamic-header-component/DynamicHeaderComponent.vue';
import DownloadButtonsComponent from './download-buttons-component/DownloadButtonsComponent.vue';

import getCurrentIndicatorTitle from 'src/composables/get_indicator_title';
import getIndicatorDescription from 'src/composables/get_indicator_description';
import getIndicatorModel from 'src/composables/get_indicator_model';
import getDynamicHeader from 'src/composables/get_dynamic_header';

import fetchData from 'src/composables/fetch_data';

const props = defineProps({
  indicatorType: { type: String, required: true },
});

const indicatorDataModel = getIndicatorModel(props.indicatorType);
const indicatorTitle = getCurrentIndicatorTitle(props.indicatorType);
const indicatorDesciption = computed(() => getIndicatorDescription(props.indicatorType, indicatorDataModel.toggleSelectedValue));
const dynamicHeader = computed(() => getDynamicHeader(indicatorDataModel, props.indicatorType));

const isDataFetching = ref(false);
const currentFormattedDateString = ref('');

let data = {};

const getCurrentFormattedDate = () => {
  const date = new Date();
  const options = { day: '2-digit', month: '2-digit', year: 'numeric' };
  return date.toLocaleDateString(undefined, options);
};

const isSeparatorNeeded = computed(() => !(['indicator_7_8', 'indicator_9', 'indicator_14', 'indicator_17'].includes(props.indicatorType)));

watchEffect( async() => {
  try {
    isDataFetching.value = false;
    currentFormattedDateString.value = getCurrentFormattedDate();

    if (indicatorDataModel.isUserQueryValid) {
      isDataFetching.value = true;
      const fetchedData = await fetchData(props.indicatorType, indicatorDataModel);

      data['colorMapData'] = fetchedData?.colorMapData;
      data['chartData'] = fetchedData?.chartData;
      isDataFetching.value = false;
    }
  } catch (error) {
    console.error(props.indicatorType, error);
  }
})

</script>

<style lang="scss" scoped>
@use './indicator-component-stylesheet.scss';
</style>